#include <stdio.h>

long min(long x, long y)
{
    if(x > y)
        return y;
    return x;
}

int main()
{
    int N, O;
    scanf("%d %d", &N, &O);
    long d[N];
    long p[N];
    for(int i = 0; i < N; i++)
    {
        scanf("%ld %ld", &d[i], &p[i]);
    }
    long k[O];
    for(int i = 0; i < O; i++)
    {
        scanf("%ld", &k[i]);
    }
    
    for(int i = 0; i < O; i++)
    {
        int ispisan = 0;
        long broj_dana = 0;
        for(int j = 0; j < N; j++)
        {
            if(d[j] > k[i] || broj_dana == k[i])
            {
                printf("%ld \n", broj_dana);
                ispisan = 1;
                break;
            }
            broj_dana =broj_dana+ min(p[j], (k[i] - d[j]+1));
        }
        if(ispisan == 0)
            printf("%ld \n", broj_dana);
    }
}